/* SPDX-License-Identifier: GPL-2.0-only */

#ifndef __USB_FSL_USB2_H
#define __USB_FSL_USB2_H

enum fsl_usb2_operating_modes {
	FSL_USB2_MPH_HOST,
	FSL_USB2_DR_HOST,
	FSL_USB2_DR_DEVICE,
	FSL_USB2_DR_OTG,
};

enum fsl_usb2_phy_modes {
	FSL_USB2_PHY_NONE,
	FSL_USB2_PHY_ULPI,
	FSL_USB2_PHY_UTMI,
	FSL_USB2_PHY_UTMI_WIDE,
	FSL_USB2_PHY_SERIAL,
};

struct fsl_usb2_platform_data {
	/* board specific information */
	enum fsl_usb2_operating_modes	operating_mode;
	enum fsl_usb2_phy_modes		phy_mode;
	unsigned int			port_enables;
};

struct fsl_udc;

struct fsl_udc *ci_udc_register(struct device *dev, void __iomem *regs);
void ci_udc_unregister(struct fsl_udc *);

#endif /* __USB_FSL_USB2_H */
